/* @pjs pauseOnBlur=true; */
//===================================
//  ©J.Roussel -- 3 dec. 2013
//========== IDEES ==================

float omega=0.05;// vitesse angulaire (en radian/frame)
int n=1;
int time,periode;//unité =durée d'une frame
boolean playing = true;
int axe1,axe2;//demi-axes d el'ellispe

void setup() {
  size(400, 400);
  frameRate(20);
  smooth();
  time=0;
  periode=round(TWO_PI/omega);
  axe1=120;axe2=70;
  text("", 0, 0);  // force Processing to load a font
//  textAlign(LEFT,BOTTOM);
}

void draw() {
  if(time<=periode){
  trace_osculateur();
  trace_trajectoire();
//  trace_rayons();
  trace_developpee();
  time+=1;
  }
  else{pause();time=0;}  
  }

//tracé de M(t) avec le cercle osculateur
void trace_osculateur(){
  background(255);
  float v_square=sq(dotposX(time))+sq(dotposY(time));
  float P=ddotposX(time)*dotposY(time)-ddotposY(time)*dotposX(time);
  float pX=posX(time);
  float pY=posY(time);
  float posXC=pX+dotposY(time)*v_square/P;
  float posYC=pY-dotposX(time)*v_square/P;
  int diametre=2*int(sqrt(sq(pX-posXC)+sq(pY-posYC)));
  float posXT=pX+30*dotposX(time)/sqrt(v_square);
  float posYT=pY+30*dotposY(time)/sqrt(v_square);  
  float posXN=pX-30*dotposY(time)/sqrt(v_square);
  float posYN=pY+30*dotposX(time)/sqrt(v_square); 
  pushMatrix();
  translate(width/2, height/2);
  noFill(); stroke(150,160,170);
  ellipse(posXC,posYC,diametre,diametre);
  line(pX,pY,posXC,posYC);
  stroke(250,0,0);
  arrow(pX,pY,posXT,posYT);
  arrow(pX,pY,posXN,posYN);
  noStroke();fill(0);
  ellipse(pX, pY,5,5);
  fill(150,0,0);
  ellipse(posXC,posYC,5,5);
  popMatrix();
 }


void trace_developpee() {
  pushMatrix();
  translate(width/2, height/2);
  noFill();stroke(150,0,0);
  beginShape();
  for(int i=1;i<=periode;i+=2){
  float v_square=sq(dotposX(i))+sq(dotposY(i));
  float P=ddotposX(i)*dotposY(i)-ddotposY(i)*dotposX(i);
  float pX=posX(i);
  float pY=posY(i);
  float posXC=pX+dotposY(i)*v_square/P;
  float posYC=pY-dotposX(i)*v_square/P;
  vertex(posXC,posYC);
  }
  endShape(CLOSE);
  popMatrix();
}

void trace_rayons() {
  pushMatrix();
  translate(width/2, height/2);
  stroke(150,0,0,100);
  for(int i=1;i<=periode;i++){
  float v_square=sq(dotposX(i))+sq(dotposY(i));
  float P=ddotposX(i)*dotposY(i)-ddotposY(i)*dotposX(i);
  float pX=posX(i);
  float pY=posY(i);
  float posXC=pX+10*dotposY(i)*v_square/P;
  float posYC=pY-10*dotposX(i)*v_square/P;
  line(pX,pY,posXC,posYC);
  }
  endShape(CLOSE);
  popMatrix();
}

void trace_trajectoire(){
  pushMatrix();
  translate(width/2, height/2);
  noFill();stroke(10);
  beginShape();
  for(int i=1;i<periode;i+=2){
  float pX=posX(i);
  float pY=posY(i);
  vertex(pX,pY);
  }
  endShape(CLOSE);
   popMatrix();
 }

float posX(int temps){
return axe1*cos(omega*temps);}

float posY(int temps){
return axe2*sin(n*omega*temps);}

float dotposX(int temps){
return -axe1*omega*sin(omega*temps);}

float dotposY(int temps){
return axe2*n*omega*cos(n*omega*temps);
}

float ddotposX(int temps){
return -axe1*sq(omega)*cos(omega*temps);}

float ddotposY(int temps){
return -axe2*sq(omega*n)*sin(n*omega*temps);
}

void arrow(float x1, float y1, float x2, float y2) {
  fill(0,0,150);stroke(0,0,250);
  strokeWeight(2);
  line(x1, y1, x2, y2);
  pushMatrix();
  translate(x2, y2);
  rotate(atan2(y2-y1, x2-x1));
  triangle(0, 0, -5, 2, -5, -2);
  popMatrix();
 strokeWeight(1); 
} 




/*** Start playback */
void play() {
  playing = true;
  loop();
} 
/*** Pause playback */
void pause() {
  playing = false;
  fill(127, 127, 127, 127);noStroke();
  rect(0, 0, width, height);
  fill(0);
  String pausetext = " click to play/pause";
  textSize(16);
  float twidth = textWidth(pausetext);
  text(pausetext, (width-twidth)/2, 20);
  textSize(10);
  noLoop();
}


void mouseClicked() {
  if (!playing) { 
    play();
  }
  else { 
    pause();
  }
}