/* @pjs pauseOnBlur=true; */
//=============================================================================
//  ©J.Roussel -- 3 dec. 2013
//========== IDEES ==================

int R=70;//rayon du du cercle
int omega=2;// vitesse angulaire (en degré/frame)
int time,periode;//unité =durée d'une frame
float posX, posY;//coordonnées du pointM
boolean playing = true;

void setup() {
  size(500, 250);
  frameRate(20);
  smooth();
  time=0;
  periode=int(360/omega);
  text("", 0, 0);  // force Processing to load a font
  background(255);
  trace_axes();
  
    
}

void draw() {
  if(time<=periode){
  trace_trajectoire();
  time+=1;
  }
  else{
    pause(); trace_axes();time=0;}  
}

void trace_trajectoire(){
  pushMatrix();
  fill(255);noStroke();
  rect(0,0,width/2-20,height);
  translate(width/4, height/2);
  ellipseMode(CENTER);
  stroke(150, 0, 0);fill(150, 0, 0,100);
  ellipse(0, 0, 2*R, 2*R);
  stroke(100);fill(255);
  arc(0, 0, 2*R,2*R, 0,TWO_PI-radians(omega*time));
  fill(0);
  line(-10,0,R+10,0);
  text("x",R+5,-5);
  line(0,10,0,-R-10);
  text("y",5,-R-5);
  posX=R*cos(radians(omega*time));
  posY=-R*sin(radians(omega*time));
  line(0,0,posX,posY);
  noStroke();fill(0);
  ellipse(posX, posY, 10, 10);
//tracé de s(t)
  translate(width/4,0);
  translate(time,height/2-20);
  fill(150,0,0,200);
  ellipse(0,-omega*time/2,3,3);
  popMatrix();
}

void trace_axes(){
  noStroke();fill(255);textSize(12);
  rect(width/2,0,width,height);
  pushMatrix();
  fill(0);stroke(0);
  translate(width/2, height-20);
  line(-20,0,periode+20,0);
  text("temps",periode+10,15);
  line(periode,-2,periode,2);
  text("T",periode,-10);
  beginShape(TRIANGLES);
  vertex(periode+20,-5);
  vertex(periode+25, 0);
  vertex(periode+20, 5);
  endShape();
  line(0,20,0,-height+30);
  beginShape(TRIANGLES);
  vertex(5,-height+35);
  vertex(0,-height+30);
  vertex(-5,-height+35);
  endShape();
  line(-2,-180,2,-180);
  text("s(t)",10,-height+30);
  text("2\u03C0 R",5,-180);
  line(-2,-90,2,-90);
  text("\u03C0 R",5,-90);
  popMatrix();
}


/*** Start playback */
void play() {
  playing = true;
  loop();
} 
/*** Pause playback */
void pause() {
  playing = false;
//  fill(127, 127, 127, 127);
  noFill();noStroke();
  rect(0, 0, width, height);
  fill(100);
  String pausetext = " click to play/pause";
  textSize(20);
  float twidth = textWidth(pausetext);
  text(pausetext, (width/2-twidth)/2, 20);
  textSize(10);
  noLoop();
}


void mouseClicked() {
  if (!playing) { 
    play();
  }
  else { 
    pause();
  }
}


